#!/usr/bin/python -tt
# Matthieu Pichene

"""
Created on Wed Oct 28 17:41:03 2015

@author: mpichene
"""

import numpy as np
import sys

def ipfp(Table,Alpha,Beta,Error): 
    """   
    fit matrix to values
    """
    Sum = Table.sum()
    if Sum !=0:
        Table = Table/Sum
    else:
        sys.exit('ERROR: Empty table')
        
    ErrorValueReached = False
    Iteration = 0
    while not ErrorValueReached and Iteration<6:
        #Alpha fit and error test
        MaxError = 0
        for i in range(len(Table)): 
            Array = Table[i]
            ASum = Array.sum()
            if ASum != 0:
                ActualError = abs(ASum-Alpha[i])
                if ActualError > MaxError:
                    MaxError = ActualError
                for j in range(len(Array)):
                    Table[i][j] = Table[i][j] * Alpha[i] / ASum  
        Table = Table.transpose()
        #Beta fit
        for i in range(len(Table)): 
            Array = Table[i]
            ASum = Array.sum()
            if ASum != 0:
                for j in range(len(Array)):
                    Table[i][j] = Table[i][j] * Beta[i] / ASum  
        Table = Table.transpose()
        if Error > MaxError:
            ErrorValueReached = True
        Iteration += 1
    # Now repair error
    Zerosearch = Table.transpose()
    LastNonZero = []
    for i in range(len(Zerosearch)): #search last value before 0
        Count = -1
        while -Count < len(Zerosearch[i])+1 and Zerosearch[i][Count]==0 : #maybe close to 0
            Count -=1
        LastNonZero.append(len(Zerosearch[i])+Count)
    Newtable = [[0 for x in range(len(Table))] for x in range(len(Table))]
    for i in range(len(Table)): # fix values
        for j in range(len(Table[i])):
            if LastNonZero[j]==i:
                Betaval = Beta[j]
                for k in range(i):
                    Betaval -= Newtable[k][j]
                    if Betaval<0:
                        Betaval=0
                Newtable[i][j] = Betaval
        Lineval = Alpha[i] - sum(Newtable[i]) # value to reach
        if Lineval<0:
            Lineval=0
        Linetot = 0 #value we have
        for j in range(len(Table[i])):
            if Table[i][j] >0 and LastNonZero[j]!=i:
                Linetot += Table[i][j]
        for j in range(len(Table[i])):
            if Table[i][j] >0 and LastNonZero[j]!=i:
                Newtable[i][j] = Table[i][j]*Lineval/Linetot
    Newtable = np.array(Newtable)
    return Newtable
        
#Example :
#{"['1']": [[1, 0.22784513415094235], [2, 0.7703238628115929], [3, 0.0018310030374647174]], "['0']": [[1, 0.7874621906157849], [2, 0.21211391456777937], [0, 0.00042389481643571305]], "['3']": [[1, 0.8098322335460338], [0, 0.1791598335965285], [2, 0.011007932857437881]], "['2', '3']": [[6, 0.48076852268854525], [1, 0.09560233740175568], [5, 0.0001658472550446601], [0, 3.142678279541155e-05], [7, 0.3272724250856749], [2, 0.08293287197891325], [8, 0.0015833612192115132], [3, 0.0006656981576804741], [11, 0.007923641178877278], [10, 3.0495772222853135e-06], [12, 0.003049314836252363], [13, 1.503838026975584e-06]], "['1', '2']": [[6, 0.057655618166753166], [7, 0.5246062179296743], [8, 0.0018309931292530327], [3, 1.0308943686170298e-08], [2, 0.00020015110076433503], [11, 0.16816280069210654], [12, 0.24529476629455807], [16, 0.0020267056921981002], [17, 0.00022273668574886935]], '1': [[1, 0.22784513415094235], [2, 0.7703238628115929], [3, 0.0018310030374647174]], '0': [[1, 0.7874621906157849], [2, 0.21211391456777937], [0, 0.00042389481643571305]], '3': [[1, 0.8098322335460338], [0, 0.1791598335965285], [2, 0.011007932857437881]], '2': [[1, 0.5840929124688371], [0, 0.00020016141181187293], [2, 0.4134574846978569], [3, 0.002249441421494218]], "['2']": [[1, 0.5840929124688371], [0, 0.00020016141181187293], [2, 0.4134574846978569], [3, 0.002249441421494218]]}
def TranslateDictTable(Values,Dict,NbVal):
    """   
    Take a couple of values from the dictionnary and recreate the tables.
    """
    return Values
    
def main(): 
    """   
    Main function
    """
    #example
    #Matrix = np.matrix('0.1 0.05;0.2,0.15')
    #Alpha = np.matrix('0.2;0.8')  
    #Beta = np.matrix('0.6 0.4')
    '''
    Table = np.array([[0.1, 0.05],[0.2,0.15]])
    Alpha = np.array([0.2,0.8])  
    Beta = np.array([0.6,0.4])
    Error = 0.01
    '''
    
    
    #(1 2)
    Table = np.array([[0.0,0.0,0.0,0.0,0.0],[0.0,0.057655618166753166,0.16816280069210654,0.0020267056921981002,0.0],[0.00020015110076433503,0.5246062179296743,0.24529476629455807,0.00022273668574886935,0.0],[1.0308943686170298e-08,0.0018309931292530327,0.0,0.0,0.0],[0.0,0.0,0.0,0.0,0.0]])

    #1
    Alpha = np.array([0, 0.22784513415094235, 0.7703238628115929, 0.0018310030374647174 , 0]) 
    #2
    Beta = np.array([0.00020016141181187293, 0.5840929124688371,  0.4134574846978569,  0.002249441421494218, 0])
    Error = 0.01
    
    '''
    Table = np.array([[0,0,0,0.1,0.05],[0.1,0.1,0.1,0,0],[0,0.1,0,0.05,0],[0.1,0,0.1,0,0],[0,0,0,0,0.2]])
    Alpha = np.array([0.2,0.2,0.2,0.2,0.2])  
    Beta = np.array([0.2,0.2,0.2,0.2,0.2])  
    Error = 0.0001
    '''
    ipfp(Table,Alpha,Beta,Error)
    
if __name__ == '__main__':
    main()